﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Runtime.InteropServices;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        ShapeFileFeatureLayer aShapeLayer = null;

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                winformsMap1.MapUnit = GeographyUnit.Meter;
                winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 198, 255, 255));

                //Layer for simply displaying countries as a simple area style.
                aShapeLayer = new ShapeFileFeatureLayer(@"Maranhao.shp");
                aShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.County1;
                aShapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20; 
                LayerOverlay staticOverlay = new LayerOverlay();
                staticOverlay.Layers.Add("WorldShapeLayer", aShapeLayer);
                winformsMap1.Overlays.Add(staticOverlay);
                aShapeLayer.Open();
                winformsMap1.CurrentExtent = aShapeLayer.GetBoundingBox();
                aShapeLayer.Close();
                winformsMap1.Refresh();
            }
            catch (Exception ex)
            {
                System.Windows.Forms.MessageBox.Show(ex.Message);
            }
        }
        [DllImport("kernel32.dll", SetLastError = true, CharSet = CharSet.Auto)]

        private static extern int GetShortPathName(
        [MarshalAs(UnmanagedType.LPTStr)] string path,
        [MarshalAs(UnmanagedType.LPTStr)] StringBuilder shortPath,
        int shortPathLength);

        public static string GetShortPathName(string path)
        {
            StringBuilder shortPath = new StringBuilder(500);
            if (0 == GetShortPathName(path, shortPath, shortPath.Capacity))
            {
                if (Marshal.GetLastWin32Error() == 2)
                {
                    throw new Exception("Since the file/folder doesn't exist yet, the system can't generate short name.");
                }
                else
                {
                    throw new Exception("GetShortPathName Win32 error is " + Marshal.GetLastWin32Error());
                }
            }
            return shortPath.ToString();
        }


        private void button1_Click(object sender, EventArgs e)
        {
            aShapeLayer.Open();
            string path;
            //path = GetShortPathName(System.IO.Path.GetDirectoryName(Application.ExecutablePath)+@"\maranhao.shp");
            path = System.IO.Path.GetDirectoryName(Application.ExecutablePath) + @"\maranhao.shp";
            string SQL = string.Format("SELECT * FROM {0}", path);
            DataTable layerData = aShapeLayer.QueryTools.ExecuteQuery(string.Format(SQL));
            aShapeLayer.Close();
        }
    }
}
